/***********************************************************************************************************************
 *
 * blueBill Mobile - open source birdwatching
 * ==========================================
 *
 * Copyright (C) 2009, 2010 by Tidalwave s.a.s. (http://www.tidalwave.it)
 * http://bluebill.tidalwave.it/mobile/
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * $Id: JaxpXmlParser.java,v 8cd0d65772ce 2010/07/11 11:24:08 fabrizio $
 *
 **********************************************************************************************************************/
package it.tidalwave.mobile.xml.jaxp;

import it.tidalwave.mobile.xml.XmlParser;
import javax.annotation.Nonnull;
import java.io.InputStream;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id: $
 *
 **********************************************************************************************************************/
public class JaxpXmlParser extends XmlParser
  {
    private final DocumentBuilderFactory builderFactory = DocumentBuilderFactory.newInstance();

    public JaxpXmlParser()
      {
        builderFactory.setValidating(false);
        builderFactory.setNamespaceAware(true);
      }

    @Override @Nonnull
    public Object parse (final @Nonnull InputStream is)
      throws Exception
      {
        final DocumentBuilder documentBuilder = builderFactory.newDocumentBuilder();
        documentBuilder.setEntityResolver(entityResolver);
        return documentBuilder.parse(is);
      }
  }
